#include"hw_memmap.h"
#include"hw_types.h"
#include"ssi.h"
#include"hw_ints.h"
#include"sysctl.h"
#include"gpio.h"
#include"timer.h"
#include"interrupt.h"
#define uint unsigned int
#define uchar unsigned char
#define ulong unsigned long
uchar disp_buf[6];
uchar disp_buf1[6];
uchar disp_tab[13]={0x003f,0x0006,0x005b,0x004f,0x0066,0x006d,0x007d,0x0007,0x007f,0x006f,0x003e,0x0038,0x0080};
ulong TheSysClock=6000000;
float  temp;
ulong  num,counter,speed,mile;
uchar v_qian,v_bai,v_shi,v_ge,l_qian,l_bai,l_shi,l_ge;
ulong ulClock,ulBitRate;
//  ſ  
#define  PULSE_PERIPH SYSCTL_PERIPH_GPIOD
#define  PULSE_PORT   GPIO_PORTD_BASE
#define  PULSE_PIN    GPIO_PIN_4
extern jtagwait(void);
//SSIʼ
void ssiInit(void)
{  ulBitRate=TheSysClock/10;
   SysCtlPeripheralEnable(SYSCTL_PERIPH_SSI0);//ʹSSIģ
   SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);//ʹSSI
   GPIOPinTypeSSI(GPIO_PORTA_BASE, GPIO_PIN_2);//(SSI0CLK_PORT, SSI0CLK_PIN);//GPIOΪSSI 
   GPIOPinTypeSSI(GPIO_PORTA_BASE, GPIO_PIN_3);//PA3  SSI0FSS_PORT
   GPIOPinTypeSSI(GPIO_PORTA_BASE, GPIO_PIN_4);//PA4  SSI0RX_PORT
   GPIOPinTypeSSI(GPIO_PORTA_BASE, GPIO_PIN_5);//PA5  SSI0TX_PORT
   SSIConfig(SSI0_BASE, SSI_FRF_MOTO_MODE_0, SSI_MODE_MASTER, ulBitRate, 16);//SSIãַЭʽ/ģʽλʣݿ
   SSIEnable(SSI0_BASE);//  ʹSSIշ
}
//ʱ2Aʼ
void timer2AInit()
{   ulClock = TheSysClock/150;// (60 * 8);//ɨٶ60Hzʱ,۲ŲԸе˸
    SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER2);     //ʹTimerģ
	TimerConfigure(TIMER2_BASE,TIMER_CFG_32_BIT_PER);//Ϊ32λڶʱ
	TimerPrescaleSet(TIMER2_BASE,TIMER_BOTH,100);//÷Ƶֵ
    TimerLoadSet(TIMER2_BASE, TIMER_A, ulClock);    //  Timerֵ
	TimerIntEnable(TIMER2_BASE, TIMER_TIMA_TIMEOUT);//  ʹTimerʱж
 // IntPrioritySet(INT_TIMER0A,2<<5);
	IntEnable(INT_TIMER2A);                         //  ʹTimerж
    IntMasterEnable();                              //  ʹܴж
    TimerEnable(TIMER2_BASE,TIMER_A);//ʹTIMER0A 
}
//ʱ1ʼ
void timer1AInit()
{   ulClock = TheSysClock /150;// (60 * 8);//ɨٶ60Hzʱ,۲ŲԸе˸
    SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER1);     //ʹTimerģ
	TimerConfigure(TIMER1_BASE,TIMER_CFG_32_BIT_PER);//Ϊ32λڶʱ
	TimerPrescaleSet(TIMER1_BASE,TIMER_BOTH,100);//÷Ƶֵ
    TimerLoadSet(TIMER1_BASE, TIMER_A, ulClock);    //  Timerֵ
	TimerIntEnable(TIMER1_BASE, TIMER_TIMA_TIMEOUT);//  ʹTimerʱж
	IntEnable(INT_TIMER1A);                         //  ʹTimerж
    IntMasterEnable();                              //  ʹܴж
    TimerEnable(TIMER1_BASE,TIMER_A);//ʹTIMER0A 
}
//ʱ0ʼ
void timer0AInit()
{   ulClock = TheSysClock/10 ;// (60 * 8);//ɨٶ60Hzʱ,۲ŲԸе˸
    SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);     //ʹTimerģ
	TimerConfigure(TIMER0_BASE,TIMER_CFG_32_BIT_PER);//Ϊ32λڶʱ
	TimerPrescaleSet(TIMER0_BASE,TIMER_BOTH,100);//÷Ƶֵ
    TimerLoadSet(TIMER0_BASE, TIMER_A, ulClock);    //  Timerֵ
	TimerIntEnable(TIMER0_BASE, TIMER_TIMA_TIMEOUT);//  ʹTimerʱж
 // IntPrioritySet(INT_TIMER1A,2<<5);
	IntEnable(INT_TIMER0A);                         //  ʹTimerж
    IntMasterEnable();                              //  ʹܴж
    TimerEnable(TIMER0_BASE,TIMER_A);//ʹTIMER0A 
}
//ϵͳʱӳʼ
void systeminit()
{   SysCtlClockSet(SYSCTL_SYSDIV_1|SYSCTL_USE_OSC|SYSCTL_OSC_MAIN|SYSCTL_XTAL_6MHZ);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC|PULSE_PERIPH);
	//GPIOPadConfigSet(PULSE_PORT,PULSE_PIN,GPIO_STRENGTH_4MA, GPIO_PIN_TYPE_STD_WPU )
	GPIOPinTypeGPIOInput(PULSE_PORT,PULSE_PIN);//ôſPD4Ϊ
	GPIOIntTypeSet(PULSE_PORT, PULSE_PIN,GPIO_FALLING_EDGE);//GPIO_LOW_LEVEL);
	GPIOPinIntEnable(PULSE_PORT, PULSE_PIN);
	IntEnable(INT_GPIOD);
}
void GPIO_D_IntHandler(void)
{
ulong ulstatus;
ulstatus=GPIOPinIntStatus(PULSE_PORT,true);//ȡж״̬
GPIOPinIntClear(PULSE_PORT,ulstatus);
if(ulstatus&PULSE_PIN)
{counter++;
//while(GPIOPinRead(PULSE_PORT, PULSE_PIN)==0xff);
}
}

int main()
{	jtagwait();//ȴjtag	 
	systeminit();
	timer0AInit();
	ssiInit();
	while(1)
	{
	if(num==10)//ÿһһ
		{		
		{temp=counter*31.41/6;
		 speed=temp*36;	 //m/skm/h
		 temp=temp*0.01;
		 mile=mile+temp;   		  
		} 
		num=0;
		counter=0;
		}  	
	if (GPIOPinRead(GPIO_PORTC_BASE, GPIO_PIN_4) == 0x00)//KEYʾ̣ʾٶ
          {timer2AInit();}
	  else
	      {timer1AInit();}
}	  
}
void Timer2ATimeoutIntHandler(void) //жϷ
{	 TimerIntClear(TIMER2_BASE,TIMER_TIMA_TIMEOUT);//жϱ־λ
	 v_qian=speed/1000;v_bai=speed/100%10;v_shi=speed/10%10;v_ge=speed%10; 
	 disp_buf[0]=10;disp_buf[1]=v_qian;disp_buf[2]=v_bai;disp_buf[3]=12;disp_buf[4]=v_shi;disp_buf[5]=v_ge;
	 SSIDataPut(SSI_BASE,0xfe00|(disp_tab[disp_buf[0]]));
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xfd00|disp_tab[disp_buf[1]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xfb00|disp_tab[disp_buf[2]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xf700|disp_tab[disp_buf[3]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xef00|disp_tab[disp_buf[4]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xdf00|disp_tab[disp_buf[5]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000));
	}
void Timer1ATimeoutIntHandler(void)
{    TimerIntClear(TIMER1_BASE,TIMER_TIMA_TIMEOUT);
	 l_qian=mile/1000;l_bai=mile/100%10;l_shi=mile/10%10;l_ge=mile%10;
	 disp_buf1[0]=11;disp_buf1[1]=l_qian;disp_buf1[2]=l_bai;disp_buf1[3]=l_shi;disp_buf1[4]=12;disp_buf1[5]=l_ge;	   
	 SSIDataPut(SSI_BASE,0xfe00|(disp_tab[disp_buf1[0]]));
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xfd00|disp_tab[disp_buf1[1]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xfb00|disp_tab[disp_buf1[2]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xf700|disp_tab[disp_buf1[3]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xef00|disp_tab[disp_buf1[4]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000)); 
	 SSIDataPut(SSI_BASE,0xdf00|disp_tab[disp_buf1[5]]);
	 SysCtlDelay(1* (SysCtlClockGet( )/ 3000));
}
void Timer0ATimeoutIntHandler(void)
{TimerIntClear(TIMER0_BASE,TIMER_TIMA_TIMEOUT);//жϱ־λ 
num++;
}
